<?php 
session_start(); 

/*
  Radio Stations Manager for xtreamer
  -----------------------------------
  Autor:   Rolf Brugger
  Version: 0.4 (Dec 26th, 2010)
           - fixed bugs
           - ir commands no not reload the page anymore, because they are executed through javascript
  License: GPLv3
  
  This little script allows you to do two things:
  - Starting and listening to web radio stations on a web page, without the need of a TV or 
    Beamer for visual feedback. 
  - Manage and edit the radio stations online, by creating and modifying the plsx file on 
    a web page. In particular, the plsx files of the special folder MyRadio can be managed with 
    this script.
  
  Installation: 
    - Unpack the files and put them on a USB stick in the top level folder named 'MyRadio'
    - With a browser go to the address http://<ip-of-your-xtreamer>/media/sda1/radio
    - Under 'manage' add an remove stations, or copy existing plsx files to the folder MyRadio
    - Under 'stations' start and stop playing the radio streams
    - Alternatively, start and stop radio stations with your xtreamer (Menu: Internet 
      Radio -> *MyRadio*)

*/
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head><title>Radio Station Manager for xtreamer</title>

<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<meta name="description" content="">
<meta name="viewport" content="width=320; initial-scale=1.0; maximum-scale=2.0; "/>
<style type="text/css">
body {font-family: sans-serif; }
div.title {font-size: 1.3em; font-weight: bold; float:left;}
div.switchpage{text-align: right;}
img {border: 0px; }
div.switchpage img {margin-right: 10px; }
td.url {font-family: "Courier New", Courier, mono; font-size: 0.6em;}
.clear { /* generic container (i.e. div) for floating buttons */
    overflow: hidden;
    width: 100%;
}
a.button {
    background: transparent url('img/bg_button_a.png') no-repeat scroll top right;
    color: #444;
    display: block;
    float: left;
    font: normal 12px arial, sans-serif;
    height: 24px;
    margin-left: 10px;
    margin-top: 10px;
    margin-right: 6px;
    padding-right: 18px; /* sliding doors padding */
    text-decoration: none;
}
a.button span {
    background: transparent url('img/bg_button_span.png') no-repeat;
    display: block;
    line-height: 14px;
    padding: 5px 0 5px 18px;
} 
a.button:active {
    background-position: bottom right;
    color: #000;
    outline: none; /* hide dotted outline in Firefox */
}
a.button:active span {
    background-position: bottom left;
    padding: 6px 0 4px 18px; /* push text down 1px */
} 
</style>

<script language="JavaScript">
function sendIrRequest(reqStr)
{
  //alert('senReq:'+reqStr);
  xmlhttp=new XMLHttpRequest();
  xmlhttp.open("GET", "index.php?"+reqStr, false);
  xmlhttp.send();
  //xmlDoc=xmlhttp.responseXML; 
}
</script>
</head>

<body>

<?php

// Stations path for webrun. The correct drive name can be found in /tmp/ramfs/volumes/. 
// If only one USB stick is plugged in, the drive name is usually C:
$stationspath = "C:/MyRadio/";  // drive name if index.php and the plsx files are stored in the top level folder 'radio' on a USB stick

// Relative or absolute directory in the filesystem where the INDEX and .plsx files are stored. Example: "/var/www/stations/"
// This directory must be writeable by the web server
// $fsdatadir can be left empty if this script is on a USB stick and if the radio station data should be stored in the same directory.
$fsdatadir = "";

// web command to open the share where the plsx directory resides. This URL is found in the xtreamer's RC web interface -> All -> Network Shares
// if the pslx files are stored on a USB stick, this can be left empty
$xtcmd_openshare = "";
//$xtcmd_openshare = "http://192.168.1.40/videolist.php?dir=/tmp/myshare/media(FREJA:192.168.1.1).smb";

/*
Datastructure $stationlist:
Array
(
    [DRS 1] => Array
        (
            [stationurl] => http://glb-stream12.streamserver.ch/1/regi_zh_sh/mp3_128
            [filename] => DRS 1.plsx
        )
    ...
)
*/

// *** switch page
if (isset($_REQUEST['pgstations'])){$_SESSION['page']='s';}
if (isset($_REQUEST['pgmanage']  )){$_SESSION['page']='m';}

// *** show title
if (isset($_SESSION['page']) and $_SESSION['page']=='m'){
  print "<div class='title'>Radio Station Manager for xtreamer</div>";
  print "<div class='switchpage'><a href='?pgstations'>Stations</a></div>";
}
else{
  print "<div class='title'>Stations</div>";
  print "<div class='switchpage'>
        <a href='#' onClick=\"sendIrRequest('vdn');\">  <img src='img/ic_vdn.png' title='volume down'/></a>
        <a href='#' onClick=\"sendIrRequest('vmute');\"><img src='img/ic_vmute.png' title='mute' /></a>
        <a href='#' onClick=\"sendIrRequest('vup');\">  <img src='img/ic_vup.png' title='volume up'/></a>
        <a href='?pgmanage'>Manage</a>
        </div>";
}

// *** subscribe a new station
if (isset($_REQUEST['subscribe'])){
  $stationname = htmlspecialchars($_REQUEST['stationname']);
  print "<p>Adding $stationname ...</p>";
  createPlaylistFile ($_REQUEST['stationurl'], $stationname, $fsdatadir);
}


// *** unsubscribe a station
if (isset($_REQUEST['unsubscribe'])){
  print "<p>Removing {$_REQUEST['unsubscribe']} ...</p>";
  system ("rm '".$fsdatadir.$_REQUEST['unsubscribe'].".plsx'");
}


// *** plsx files are up to date now. Read them into the $stationlist
$stationlist =  getStationList($fsdatadir);


// *** start playing on xtreamer
if (isset($_REQUEST['play'])){
  //print "<p>Play station ".$_REQUEST['play']."</p>";
  if(strlen($xtcmd_openshare)){$dummy = file_get_contents($xtcmd_openshare); } // open the share first
  system ("echo 'Audio $stationspath".$_REQUEST['play'].".plsx' > /tmp/webrun");
  system ("echo -n '%' > /tmp/ir");
}


// *** stop playing on xtreamer
if (isset($_REQUEST['stop'])){
  //print "<p>Stop playing</p>";
  system ("echo -n S > /tmp/ir");
}


// *** volume control on xtreamer
if (isset($_REQUEST['vup'])){
  system("echo -n '+' > /tmp/ir");
}
if (isset($_REQUEST['vdn'])){
  system("echo -n '-' > /tmp/ir");
}
if (isset($_REQUEST['vmute'])){
  system("echo -n 'M' > /tmp/ir");
}


// *** no parameter is set
else{
  
}


// *** Show either Station Keys Page, or Stations Management Page - depending on the session variable
if (isset($_SESSION['page']) and $_SESSION['page']=='m'){
  // *** Stations Management Page
  print "<h3>Stations</h3>";
  print "<table>";
  //print "<tr><th>Station</th><th></th><th></th></tr>";
  foreach ($stationlist as $currstation => $station){
    print "<tr>";
    print "<td><a href='?play=".urlencode($currstation)."'><img src='img/ic_play.png' alt='play'/> $currstation</a></td><td class='url'>".$station['stationurl']."</td><td><a href='?unsubscribe=".urlencode($currstation)."'><img src='img/ic_remove.png' alt='remove'/></a></td>";
    print "</tr>";
  }
  print "</table>";

  print "<p><a href='?stop'><img src='img/ic_stop.png' alt='stop'/> stop playing</a></p>";

  print "<p>&nbsp;</p>
         <hr/>
         <form method='POST' action='index.php'>
         <h4>Subscribe new Station:</h4>
         <p>
         Station name: <input name='stationname' type='text' size='20' maxlength='40'>
         Stream URL: <input name='stationurl' type='text' size='40' maxlength='200'>
         <input type='submit' NAME='subscribe' VALUE='subscribe' />
         </p>
         </form>
         <form method='POST' action='index.php'>
         <hr/>
         ";
}
else{
  // *** Show Station Keys Page
  print "<h3></h3>";
  foreach ($stationlist as $currstation => $station){
    print "<a class='button' href='#' onClick=\"sendIrRequest('play=".urlencode($currstation)."');\"><span>$currstation</span></a>";
  }
//  print "<p class='clear'><br/><a class='button' href='#' onClick=\"sendIrRequest('play=SwissGroove');\"><span><b>SwissGroove</b></span></a></p>";
  print "<p class='clear'><br/><a class='button' href='#' onClick=\"sendIrRequest('stop');\"><span><b>STOP</b></span></a></p>";
}
?>


</body>
</html>

<?php

function createPlaylistFile ($stationurl, $stationname, $fsdatadir)
// creates a pslx file
//
// Example:
//
// [playlist]
// File1=http://streamer-mtc-aa02.somafm.com:80/stream/1018
// Title1=SomaFM Groove Salad
// Length1=-1
// NumberOfEntries=1
// Version=2

{
  $plsxfile = "[playlist]\nFile1=$stationurl\nTitle1=$stationname\nLength1=-1\nNumberOfEntries=1\nVersion=2\n\n";
  file_put_contents(($fsdatadir.$stationname.".plsx"), $plsxfile);
}

function getStationList($dir)
// reads all plsx files in the directory $dir and returns a hash containing the file name, the station name and the station url
{
  $stationlist = array();
  if ($dir==''){$dir='./';};
  $files = scandir($dir);
  foreach($files as $filename){
    if (preg_match('/\.plsx$/', $filename)){
      $cont = explode("\n", file_get_contents($dir.$filename));
      $stationurl='';
      $stationname='';
      $i=0;
      while(($stationname=='' or $stationurl=='') and $i<count($cont)){
        if(preg_match('/^File1=(.*)$/',  $cont[$i], $matches)){$stationurl = $matches[1];}
        if(preg_match('/^Title1=(.*)$/', $cont[$i], $matches)){$stationname= $matches[1];}
        $i++;
      }
      $stationlist[$stationname] = array('stationurl' => $stationurl, 'filename' => $filename);
    }
  }
  return($stationlist);
}

/*
IR-Actions (from /sbin/www/rc/rc_action.php)

if ($_POST['power']){
        exec("echo -n O > /tmp/ir");
}else if ($_POST['subt']){
        exec("echo -n '!s ' > /tmp/ir");

}else if ($_POST['home']){
        exec("echo -n '!' > /tmp/ir");
}else if ($_POST['1']){
        exec("echo -n a > /tmp/ir");
}else if ($_POST['2']){
        exec("echo -n e > /tmp/ir");
}else if ($_POST['3']){
        exec("echo -n d > /tmp/ir");
}else if ($_POST['4']){
        exec("echo -n z > /tmp/ir");
}else if ($_POST['5']){
        exec("echo -n g > /tmp/ir");
}else if ($_POST['6']){
        exec("echo -n m > /tmp/ir");
}else if ($_POST['7']){
        exec("echo -n s > /tmp/ir");
}else if ($_POST['8']){
        exec("echo -n f > /tmp/ir");
}else if ($_POST['9']){
        exec("echo -n t > /tmp/ir");
}else if ($_POST['info']){
        exec("echo -n i > /tmp/ir");
}else if ($_POST['0']){
        exec("echo -n v > /tmp/ir");
}else if ($_POST['return']){
        exec("echo -n r > /tmp/ir");

}else if ($_POST['up']){
        exec("echo -n k > /tmp/ir");
}else if ($_POST['left']){
        exec("echo -n h > /tmp/ir");
}else if ($_POST['enter']){
        exec("echo -n ' ' > /tmp/ir");
}else if ($_POST['right']){
        exec("echo -n l > /tmp/ir");
}else if ($_POST['down']){
        exec("echo -n j > /tmp/ir");


}else if ($_POST['play_pause']){
        exec("echo -n p > /tmp/ir");
}else if ($_POST['stop']){
        exec("echo -n S > /tmp/ir");
}else if ($_POST['pgup']){
        exec("echo -n '{' > /tmp/ir");
}else if ($_POST['pgdn']){
        exec("echo -n '}' > /tmp/ir");

}else if ($_POST['FF']){
        exec("echo -n '>' > /tmp/ir");
}else if ($_POST['FB']){
        exec("echo -n '<' > /tmp/ir");

}else if ($_POST['vol_up']){
        exec("echo -n '+' > /tmp/ir");
}else if ($_POST['vol_down']){
        exec("echo -n '-' > /tmp/ir");

}else if ($_POST['audio']){
        exec("echo -n A > /tmp/ir");
}else if ($_POST['a-b']){
        exec("echo -n '@' > /tmp/ir");
}else if ($_POST['repeat']){
        exec("echo -n '&' > /tmp/ir");


}else if ($_POST['shufl']){
        exec('echo -n u > /tmp/ir');
}else if ($_POST['mute']){
        exec("echo -n M > /tmp/ir");
}else if ($_POST['subtitle']){
        exec("echo -n T > /tmp/ir");
}else if ($_POST['sync_left']){
        exec("echo -n '.' > /tmp/ir");
}else if ($_POST['sync_right']){
        exec("echo -n '/' > /tmp/ir");

}else {
        $command=$_POST['command'];
        $fp=fopen('/tmp/netkey.data', 'w');
        fwrite($fp, $command);
        fclose($fp);
        exec("echo -n r > /tmp/ir");

}

*/

?>
